using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Transactions;
using MySql.Data.MySqlClient;

namespace TESTAPPBUG35330
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MySqlConnection myConnection = new MySqlConnection("server=xxx.xxx.xx.xx;user id=xxxxx;Password=xxxxxx;database=atomic3;connect timeout=60000; auto enlist=false;pooling=false;convert zero datetime=yes;use procedure bodies=True;use old syntax=false;Allow User Variables=true;logging=true;");
            myConnection.Open();
            MySqlTransaction myTrans = null;
            // Start a local transaction
            myTrans = myConnection.BeginTransaction();
            // Must assign both transaction object and connection
            // to Command object for a pending local transaction
            MySqlCommand myCommand = new MySqlCommand("DROP TABLE IF EXISTS TEST1", myConnection);
            myCommand.Connection = myConnection;
            myCommand.Transaction = myTrans;
            myCommand.ExecuteNonQuery();
            myCommand.CommandText = "CREATE TABLE TEST1(NAME VARCHAR(50) NOT NULL DEFAULT 'Some text')ENGINE=InnoDB;";
            myCommand.ExecuteNonQuery();
            try
            {
                myCommand.CommandText = "INSERT INTO TEST1 VALUES ('DIARMUID')";
                myCommand.ExecuteNonQuery();
                myTrans.Rollback();

            }
            catch (Exception exc)
            {
                try
                {
                    myTrans.Rollback();
                }
                catch (MySqlException ex)
                {
                    if (myTrans.Connection != null)
                    {
                        MessageBox.Show("Transaction FAILED!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
                MessageBox.Show("Transaction FAILED!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            myTrans.Dispose();
            myCommand.Dispose();
            myConnection.Close();
            myConnection.Dispose();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            MySqlConnection myConnection = new MySqlConnection("server=xxx.xxx.xx.xx;user id=xxxxx;Password=xxxxxx;database=atomic3;connect timeout=60000; auto enlist=false;pooling=false;convert zero datetime=yes;use procedure bodies=True;use old syntax=false;Allow User Variables=true;logging=true;");
            myConnection.Open();
            MySqlTransaction myTrans = null;
            // Start a local transaction
            myTrans = myConnection.BeginTransaction();
            // Must assign both transaction object and connection
            // to Command object for a pending local transaction
            MySqlCommand myCommand = new MySqlCommand("DROP TABLE IF EXISTS TEST1", myConnection);
            myCommand.Connection = myConnection;
            myCommand.Transaction = myTrans;
            myCommand.ExecuteNonQuery();
            myCommand.CommandText = "CREATE TABLE TEST1(NAME VARCHAR(50) NOT NULL DEFAULT 'Some text')ENGINE=InnoDB;";
            myCommand.ExecuteNonQuery();
            try
            {
                myCommand.CommandText = "INSERT INTO TEST1 VALUES ('DIARMUID')";
                myCommand.ExecuteNonQuery();
                myTrans.Commit();
            }
            catch (Exception exc)
            {
                try
                {
                    myTrans.Rollback();
                }
                catch (MySqlException ex)
                {
                    if (myTrans.Connection != null)
                    {
                        MessageBox.Show("Transaction FAILED!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
                MessageBox.Show("Transaction FAILED!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            myTrans.Dispose();
            myCommand.Dispose();
            myConnection.Close();
            myConnection.Dispose();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                TransactionOptions options = new TransactionOptions();
                options.IsolationLevel = System.Transactions.IsolationLevel.RepeatableRead;
                options.Timeout = new TimeSpan(0, 0, 60);
                MySqlConnection conn = new MySqlConnection("server=xxx.xxx.xx.xx;user id=xxxxx;Password=xxxxxx;database=atomic3;connect timeout=60000; auto enlist=false;pooling=false;convert zero datetime=yes;use procedure bodies=True;use old syntax=false;Allow User Variables=true;logging=true;");
                conn.Open();
                MySqlCommand cmdsetup = new MySqlCommand("DROP TABLE IF EXISTS TEST1", conn);
                cmdsetup.ExecuteNonQuery();
                cmdsetup.CommandText = "CREATE TABLE TEST1(NAME VARCHAR(50) NOT NULL DEFAULT 'Some text')ENGINE=InnoDB;";
                cmdsetup.ExecuteNonQuery();
                cmdsetup.Dispose();
                conn.Close();
                conn.Dispose();
                using (TransactionScope tscope = new TransactionScope(TransactionScopeOption.Required, options))
                {
                    try
                    {
                        MySqlHelper.ExecuteNonQuery("server=xxx.xxx.xx.xx;user id=xxxxx;Password=xxxxxx;database=atomic3;connect timeout=60000; auto enlist=false;pooling=false;convert zero datetime=yes;use procedure bodies=True;use old syntax=false;Allow User Variables=true;logging=true;", "INSERT INTO TEST1 VALUES('MARK');");
                    }
                    catch (Exception TransException)
                    {
                        tscope.Dispose();
                        MessageBox.Show("Transaction rollback!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    tscope.Complete();
                }
            }
            catch (Exception TransException)
            {
                MessageBox.Show("Error!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            TransactionOptions options = new TransactionOptions();
            options.IsolationLevel = System.Transactions.IsolationLevel.RepeatableRead;
            options.Timeout = new TimeSpan(0, 0, 60);
            MySqlConnection conn = new MySqlConnection("server=xxx.xxx.xx.xx;user id=xxxxx;Password=xxxxxx;database=atomic3;connect timeout=60000; auto enlist=false;pooling=false;convert zero datetime=yes;use procedure bodies=True;use old syntax=false;Allow User Variables=true;logging=true;");
            conn.Open();
            MySqlCommand cmdsetup = new MySqlCommand("DROP TABLE IF EXISTS `bug35330`", conn);
            cmdsetup.ExecuteNonQuery();
            cmdsetup.CommandText = "CREATE TABLE IF NOT EXISTS `bug35330`(Id int(10) unsigned NOT NULL default '0', PRIMARY KEY  (Id))ENGINE=InnoDB;";
            cmdsetup.ExecuteNonQuery();
            cmdsetup.Dispose();
            conn.Close();
            conn.Dispose();
            //cmdsetup.CommandText = "SET autocommit = 0;";
            //cmdsetup.ExecuteNonQuery();
            //cmdsetup.CommandText = "SET sql_mode=TRADITIONAL";
            //cmdsetup.ExecuteNonQuery();
            using (TransactionScope ts = new TransactionScope(TransactionScopeOption.RequiresNew, options))
            {
                for (int i = 0; i < 50; i++)
                {
                    MySqlHelper.ExecuteNonQuery("server=xxx.xxx.xx.xx;user id=xxxxx;Password=xxxxxx;database=atomic3;connect timeout=60000; auto enlist=false;pooling=false;convert zero datetime=yes;use procedure bodies=True;use old syntax=false;Allow User Variables=true;logging=true;", String.Format("INSERT INTO bug35330 VALUES({0});", i));
                }
                ts.Complete();
            }
        }
    }
}